{%- if nginx.user is defined -%}
user {{ nginx.user }};
{% endif -%}
worker_processes {{ nginx.worker_processes | default(5) }};

events {
    worker_connections {{ nginx.worker_connections | default(1024) }};
}

http {
    server_names_hash_bucket_size {{ nginx.server_names_hash_bucket_size | default(64) }};
    include mime.types;
    {% for server in nginx.servers -%}
    server {
        {% if server.names is defined -%}
        server_name {{ server.names is string | ternary(server.names, server.names | join(' ')) }};
        {% endif -%}
        server_tokens {{ server.tokens | default(True) | ternary('on', 'off') }};
        {% if server.gzip | default(false) -%}
        gzip on;
        gzip_types {{ server.gzip_types | default(['text/html']) | join(' ') }};
        gzip_min_length {{ server.gzip_min_length | default(20) }};
        {% endif -%}
        {% if server.return is defined -%}
        return {{ server.return }};
        {% endif -%}
        {% if server.rewrite is defined -%}
        rewrite {{ server.rewrite }};
        {% endif -%}
        {% if server.addresses is defined -%}
        {% for addresses in server.addresses -%}
        listen {{ addresses }};
        {% endfor -%}
        {% endif -%}
        {% if server.allows is defined -%}
        {% for allow in server.allows -%}
        allow {{ allow }};
        {% endfor -%}
        {% endif -%}
        {% if server.denies is defined -%}
        {% for deny in server.denies -%}
        deny {{ deny }};
        {% endfor -%}
        {% endif -%}
        {% if server.root is defined -%}
        root {{ server.root }};
        {% endif -%}
        {% if server.index_files is defined -%}
        index {{ server.index_files | join(' ') }};
        {% endif -%}
        {% if server.ssl is defined -%}
        ssl_certificate {{ server.ssl.cert_file }};
        ssl_certificate_key {{ server.ssl.key_file }};
        {% endif -%}

        {% if server.php is defined -%}
        location ~ \.php$ {
            fastcgi_pass unix:{{ php_fpm_socket_path }};
            include fastcgi_params;
            {% if server.php.fastcgi_index is defined -%}
            fastcgi_index {{ server.php.fastcgi_index }}; 
            {% endif -%}
            {% for param in server.php.fastcgi_params | default({}) | dict2items -%}
            fastcgi_param {{ param.key }} {{ param.value }};
            {% endfor -%}
        }
        {% endif -%}
        {% for location in server.locations | default([]) -%}
        location {{ location.name }} {
            autoindex {{ location.autoindex | default(False) | ternary('on', 'off') }};
            {% if location.root is defined -%}
            root {{ location.root }};
            {% endif -%}
            {% if location.index_files is defined -%}
            index {{ location.index_files | join(' ') }};
            {% endif -%}
            {% if location.proxy_pass is defined -%}
            proxy_pass {{ location.proxy_pass }};
            {% endif -%}
            {% if location.proxy_bind is defined -%}
            proxy_bind {{ location.proxy_bind }};
            {% endif -%}
            {% if location.proxy_http_version is defined -%}
            proxy_http_version {{ location.proxy_http_version }};
            {% endif -%}
            {% for header in location.proxy_set_headers | default({}) | dict2items -%}
            proxy_set_header {{ header.key }} {{ header.value }};
        {% endfor -%}
        }
    {% endfor -%}
    }
{% endfor -%}
}
